// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// GetAttachmentMenuBotRequest represents TL type `getAttachmentMenuBot#3da561fb`.
type GetAttachmentMenuBotRequest struct {
	// Bot's user identifier
	BotUserID int64
}

// GetAttachmentMenuBotRequestTypeID is TL type id of GetAttachmentMenuBotRequest.
const GetAttachmentMenuBotRequestTypeID = 0x3da561fb

// Ensuring interfaces in compile-time for GetAttachmentMenuBotRequest.
var (
	_ bin.Encoder     = &GetAttachmentMenuBotRequest{}
	_ bin.Decoder     = &GetAttachmentMenuBotRequest{}
	_ bin.BareEncoder = &GetAttachmentMenuBotRequest{}
	_ bin.BareDecoder = &GetAttachmentMenuBotRequest{}
)

func (g *GetAttachmentMenuBotRequest) Zero() bool {
	if g == nil {
		return true
	}
	if !(g.BotUserID == 0) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (g *GetAttachmentMenuBotRequest) String() string {
	if g == nil {
		return "GetAttachmentMenuBotRequest(nil)"
	}
	type Alias GetAttachmentMenuBotRequest
	return fmt.Sprintf("GetAttachmentMenuBotRequest%+v", Alias(*g))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*GetAttachmentMenuBotRequest) TypeID() uint32 {
	return GetAttachmentMenuBotRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*GetAttachmentMenuBotRequest) TypeName() string {
	return "getAttachmentMenuBot"
}

// TypeInfo returns info about TL type.
func (g *GetAttachmentMenuBotRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "getAttachmentMenuBot",
		ID:   GetAttachmentMenuBotRequestTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "BotUserID",
			SchemaName: "bot_user_id",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (g *GetAttachmentMenuBotRequest) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getAttachmentMenuBot#3da561fb as nil")
	}
	b.PutID(GetAttachmentMenuBotRequestTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *GetAttachmentMenuBotRequest) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getAttachmentMenuBot#3da561fb as nil")
	}
	b.PutInt53(g.BotUserID)
	return nil
}

// Decode implements bin.Decoder.
func (g *GetAttachmentMenuBotRequest) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getAttachmentMenuBot#3da561fb to nil")
	}
	if err := b.ConsumeID(GetAttachmentMenuBotRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode getAttachmentMenuBot#3da561fb: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *GetAttachmentMenuBotRequest) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getAttachmentMenuBot#3da561fb to nil")
	}
	{
		value, err := b.Int53()
		if err != nil {
			return fmt.Errorf("unable to decode getAttachmentMenuBot#3da561fb: field bot_user_id: %w", err)
		}
		g.BotUserID = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (g *GetAttachmentMenuBotRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if g == nil {
		return fmt.Errorf("can't encode getAttachmentMenuBot#3da561fb as nil")
	}
	b.ObjStart()
	b.PutID("getAttachmentMenuBot")
	b.Comma()
	b.FieldStart("bot_user_id")
	b.PutInt53(g.BotUserID)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (g *GetAttachmentMenuBotRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if g == nil {
		return fmt.Errorf("can't decode getAttachmentMenuBot#3da561fb to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("getAttachmentMenuBot"); err != nil {
				return fmt.Errorf("unable to decode getAttachmentMenuBot#3da561fb: %w", err)
			}
		case "bot_user_id":
			value, err := b.Int53()
			if err != nil {
				return fmt.Errorf("unable to decode getAttachmentMenuBot#3da561fb: field bot_user_id: %w", err)
			}
			g.BotUserID = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetBotUserID returns value of BotUserID field.
func (g *GetAttachmentMenuBotRequest) GetBotUserID() (value int64) {
	if g == nil {
		return
	}
	return g.BotUserID
}

// GetAttachmentMenuBot invokes method getAttachmentMenuBot#3da561fb returning error if any.
func (c *Client) GetAttachmentMenuBot(ctx context.Context, botuserid int64) (*AttachmentMenuBot, error) {
	var result AttachmentMenuBot

	request := &GetAttachmentMenuBotRequest{
		BotUserID: botuserid,
	}
	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return &result, nil
}
