// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// GetChatSponsoredMessagesRequest represents TL type `getChatSponsoredMessages#50a84098`.
type GetChatSponsoredMessagesRequest struct {
	// Identifier of the chat
	ChatID int64
}

// GetChatSponsoredMessagesRequestTypeID is TL type id of GetChatSponsoredMessagesRequest.
const GetChatSponsoredMessagesRequestTypeID = 0x50a84098

// Ensuring interfaces in compile-time for GetChatSponsoredMessagesRequest.
var (
	_ bin.Encoder     = &GetChatSponsoredMessagesRequest{}
	_ bin.Decoder     = &GetChatSponsoredMessagesRequest{}
	_ bin.BareEncoder = &GetChatSponsoredMessagesRequest{}
	_ bin.BareDecoder = &GetChatSponsoredMessagesRequest{}
)

func (g *GetChatSponsoredMessagesRequest) Zero() bool {
	if g == nil {
		return true
	}
	if !(g.ChatID == 0) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (g *GetChatSponsoredMessagesRequest) String() string {
	if g == nil {
		return "GetChatSponsoredMessagesRequest(nil)"
	}
	type Alias GetChatSponsoredMessagesRequest
	return fmt.Sprintf("GetChatSponsoredMessagesRequest%+v", Alias(*g))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*GetChatSponsoredMessagesRequest) TypeID() uint32 {
	return GetChatSponsoredMessagesRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*GetChatSponsoredMessagesRequest) TypeName() string {
	return "getChatSponsoredMessages"
}

// TypeInfo returns info about TL type.
func (g *GetChatSponsoredMessagesRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "getChatSponsoredMessages",
		ID:   GetChatSponsoredMessagesRequestTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "ChatID",
			SchemaName: "chat_id",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (g *GetChatSponsoredMessagesRequest) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getChatSponsoredMessages#50a84098 as nil")
	}
	b.PutID(GetChatSponsoredMessagesRequestTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *GetChatSponsoredMessagesRequest) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getChatSponsoredMessages#50a84098 as nil")
	}
	b.PutInt53(g.ChatID)
	return nil
}

// Decode implements bin.Decoder.
func (g *GetChatSponsoredMessagesRequest) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getChatSponsoredMessages#50a84098 to nil")
	}
	if err := b.ConsumeID(GetChatSponsoredMessagesRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode getChatSponsoredMessages#50a84098: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *GetChatSponsoredMessagesRequest) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getChatSponsoredMessages#50a84098 to nil")
	}
	{
		value, err := b.Int53()
		if err != nil {
			return fmt.Errorf("unable to decode getChatSponsoredMessages#50a84098: field chat_id: %w", err)
		}
		g.ChatID = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (g *GetChatSponsoredMessagesRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if g == nil {
		return fmt.Errorf("can't encode getChatSponsoredMessages#50a84098 as nil")
	}
	b.ObjStart()
	b.PutID("getChatSponsoredMessages")
	b.Comma()
	b.FieldStart("chat_id")
	b.PutInt53(g.ChatID)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (g *GetChatSponsoredMessagesRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if g == nil {
		return fmt.Errorf("can't decode getChatSponsoredMessages#50a84098 to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("getChatSponsoredMessages"); err != nil {
				return fmt.Errorf("unable to decode getChatSponsoredMessages#50a84098: %w", err)
			}
		case "chat_id":
			value, err := b.Int53()
			if err != nil {
				return fmt.Errorf("unable to decode getChatSponsoredMessages#50a84098: field chat_id: %w", err)
			}
			g.ChatID = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetChatID returns value of ChatID field.
func (g *GetChatSponsoredMessagesRequest) GetChatID() (value int64) {
	if g == nil {
		return
	}
	return g.ChatID
}

// GetChatSponsoredMessages invokes method getChatSponsoredMessages#50a84098 returning error if any.
func (c *Client) GetChatSponsoredMessages(ctx context.Context, chatid int64) (*SponsoredMessages, error) {
	var result SponsoredMessages

	request := &GetChatSponsoredMessagesRequest{
		ChatID: chatid,
	}
	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return &result, nil
}
