// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// GetMessageAvailableReactionsRequest represents TL type `getMessageAvailableReactions#76db86b2`.
type GetMessageAvailableReactionsRequest struct {
	// Identifier of the chat to which the message belongs
	ChatID int64
	// Identifier of the message
	MessageID int64
	// Number of reaction per row, 5-25
	RowSize int32
}

// GetMessageAvailableReactionsRequestTypeID is TL type id of GetMessageAvailableReactionsRequest.
const GetMessageAvailableReactionsRequestTypeID = 0x76db86b2

// Ensuring interfaces in compile-time for GetMessageAvailableReactionsRequest.
var (
	_ bin.Encoder     = &GetMessageAvailableReactionsRequest{}
	_ bin.Decoder     = &GetMessageAvailableReactionsRequest{}
	_ bin.BareEncoder = &GetMessageAvailableReactionsRequest{}
	_ bin.BareDecoder = &GetMessageAvailableReactionsRequest{}
)

func (g *GetMessageAvailableReactionsRequest) Zero() bool {
	if g == nil {
		return true
	}
	if !(g.ChatID == 0) {
		return false
	}
	if !(g.MessageID == 0) {
		return false
	}
	if !(g.RowSize == 0) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (g *GetMessageAvailableReactionsRequest) String() string {
	if g == nil {
		return "GetMessageAvailableReactionsRequest(nil)"
	}
	type Alias GetMessageAvailableReactionsRequest
	return fmt.Sprintf("GetMessageAvailableReactionsRequest%+v", Alias(*g))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*GetMessageAvailableReactionsRequest) TypeID() uint32 {
	return GetMessageAvailableReactionsRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*GetMessageAvailableReactionsRequest) TypeName() string {
	return "getMessageAvailableReactions"
}

// TypeInfo returns info about TL type.
func (g *GetMessageAvailableReactionsRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "getMessageAvailableReactions",
		ID:   GetMessageAvailableReactionsRequestTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "ChatID",
			SchemaName: "chat_id",
		},
		{
			Name:       "MessageID",
			SchemaName: "message_id",
		},
		{
			Name:       "RowSize",
			SchemaName: "row_size",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (g *GetMessageAvailableReactionsRequest) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getMessageAvailableReactions#76db86b2 as nil")
	}
	b.PutID(GetMessageAvailableReactionsRequestTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *GetMessageAvailableReactionsRequest) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getMessageAvailableReactions#76db86b2 as nil")
	}
	b.PutInt53(g.ChatID)
	b.PutInt53(g.MessageID)
	b.PutInt32(g.RowSize)
	return nil
}

// Decode implements bin.Decoder.
func (g *GetMessageAvailableReactionsRequest) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getMessageAvailableReactions#76db86b2 to nil")
	}
	if err := b.ConsumeID(GetMessageAvailableReactionsRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode getMessageAvailableReactions#76db86b2: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *GetMessageAvailableReactionsRequest) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getMessageAvailableReactions#76db86b2 to nil")
	}
	{
		value, err := b.Int53()
		if err != nil {
			return fmt.Errorf("unable to decode getMessageAvailableReactions#76db86b2: field chat_id: %w", err)
		}
		g.ChatID = value
	}
	{
		value, err := b.Int53()
		if err != nil {
			return fmt.Errorf("unable to decode getMessageAvailableReactions#76db86b2: field message_id: %w", err)
		}
		g.MessageID = value
	}
	{
		value, err := b.Int32()
		if err != nil {
			return fmt.Errorf("unable to decode getMessageAvailableReactions#76db86b2: field row_size: %w", err)
		}
		g.RowSize = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (g *GetMessageAvailableReactionsRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if g == nil {
		return fmt.Errorf("can't encode getMessageAvailableReactions#76db86b2 as nil")
	}
	b.ObjStart()
	b.PutID("getMessageAvailableReactions")
	b.Comma()
	b.FieldStart("chat_id")
	b.PutInt53(g.ChatID)
	b.Comma()
	b.FieldStart("message_id")
	b.PutInt53(g.MessageID)
	b.Comma()
	b.FieldStart("row_size")
	b.PutInt32(g.RowSize)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (g *GetMessageAvailableReactionsRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if g == nil {
		return fmt.Errorf("can't decode getMessageAvailableReactions#76db86b2 to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("getMessageAvailableReactions"); err != nil {
				return fmt.Errorf("unable to decode getMessageAvailableReactions#76db86b2: %w", err)
			}
		case "chat_id":
			value, err := b.Int53()
			if err != nil {
				return fmt.Errorf("unable to decode getMessageAvailableReactions#76db86b2: field chat_id: %w", err)
			}
			g.ChatID = value
		case "message_id":
			value, err := b.Int53()
			if err != nil {
				return fmt.Errorf("unable to decode getMessageAvailableReactions#76db86b2: field message_id: %w", err)
			}
			g.MessageID = value
		case "row_size":
			value, err := b.Int32()
			if err != nil {
				return fmt.Errorf("unable to decode getMessageAvailableReactions#76db86b2: field row_size: %w", err)
			}
			g.RowSize = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetChatID returns value of ChatID field.
func (g *GetMessageAvailableReactionsRequest) GetChatID() (value int64) {
	if g == nil {
		return
	}
	return g.ChatID
}

// GetMessageID returns value of MessageID field.
func (g *GetMessageAvailableReactionsRequest) GetMessageID() (value int64) {
	if g == nil {
		return
	}
	return g.MessageID
}

// GetRowSize returns value of RowSize field.
func (g *GetMessageAvailableReactionsRequest) GetRowSize() (value int32) {
	if g == nil {
		return
	}
	return g.RowSize
}

// GetMessageAvailableReactions invokes method getMessageAvailableReactions#76db86b2 returning error if any.
func (c *Client) GetMessageAvailableReactions(ctx context.Context, request *GetMessageAvailableReactionsRequest) (*AvailableReactions, error) {
	var result AvailableReactions

	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return &result, nil
}
