// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// PhotosUploadContactProfilePhotoRequest represents TL type `photos.uploadContactProfilePhoto#b91a83bf`.
//
// See https://core.telegram.org/method/photos.uploadContactProfilePhoto for reference.
type PhotosUploadContactProfilePhotoRequest struct {
	// Flags field of PhotosUploadContactProfilePhotoRequest.
	Flags bin.Fields
	// Suggest field of PhotosUploadContactProfilePhotoRequest.
	Suggest bool
	// Save field of PhotosUploadContactProfilePhotoRequest.
	Save bool
	// UserID field of PhotosUploadContactProfilePhotoRequest.
	UserID InputUserClass
	// File field of PhotosUploadContactProfilePhotoRequest.
	//
	// Use SetFile and GetFile helpers.
	File InputFileClass
	// Video field of PhotosUploadContactProfilePhotoRequest.
	//
	// Use SetVideo and GetVideo helpers.
	Video InputFileClass
	// VideoStartTs field of PhotosUploadContactProfilePhotoRequest.
	//
	// Use SetVideoStartTs and GetVideoStartTs helpers.
	VideoStartTs float64
}

// PhotosUploadContactProfilePhotoRequestTypeID is TL type id of PhotosUploadContactProfilePhotoRequest.
const PhotosUploadContactProfilePhotoRequestTypeID = 0xb91a83bf

// Ensuring interfaces in compile-time for PhotosUploadContactProfilePhotoRequest.
var (
	_ bin.Encoder     = &PhotosUploadContactProfilePhotoRequest{}
	_ bin.Decoder     = &PhotosUploadContactProfilePhotoRequest{}
	_ bin.BareEncoder = &PhotosUploadContactProfilePhotoRequest{}
	_ bin.BareDecoder = &PhotosUploadContactProfilePhotoRequest{}
)

func (u *PhotosUploadContactProfilePhotoRequest) Zero() bool {
	if u == nil {
		return true
	}
	if !(u.Flags.Zero()) {
		return false
	}
	if !(u.Suggest == false) {
		return false
	}
	if !(u.Save == false) {
		return false
	}
	if !(u.UserID == nil) {
		return false
	}
	if !(u.File == nil) {
		return false
	}
	if !(u.Video == nil) {
		return false
	}
	if !(u.VideoStartTs == 0) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (u *PhotosUploadContactProfilePhotoRequest) String() string {
	if u == nil {
		return "PhotosUploadContactProfilePhotoRequest(nil)"
	}
	type Alias PhotosUploadContactProfilePhotoRequest
	return fmt.Sprintf("PhotosUploadContactProfilePhotoRequest%+v", Alias(*u))
}

// FillFrom fills PhotosUploadContactProfilePhotoRequest from given interface.
func (u *PhotosUploadContactProfilePhotoRequest) FillFrom(from interface {
	GetSuggest() (value bool)
	GetSave() (value bool)
	GetUserID() (value InputUserClass)
	GetFile() (value InputFileClass, ok bool)
	GetVideo() (value InputFileClass, ok bool)
	GetVideoStartTs() (value float64, ok bool)
}) {
	u.Suggest = from.GetSuggest()
	u.Save = from.GetSave()
	u.UserID = from.GetUserID()
	if val, ok := from.GetFile(); ok {
		u.File = val
	}

	if val, ok := from.GetVideo(); ok {
		u.Video = val
	}

	if val, ok := from.GetVideoStartTs(); ok {
		u.VideoStartTs = val
	}

}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*PhotosUploadContactProfilePhotoRequest) TypeID() uint32 {
	return PhotosUploadContactProfilePhotoRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*PhotosUploadContactProfilePhotoRequest) TypeName() string {
	return "photos.uploadContactProfilePhoto"
}

// TypeInfo returns info about TL type.
func (u *PhotosUploadContactProfilePhotoRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "photos.uploadContactProfilePhoto",
		ID:   PhotosUploadContactProfilePhotoRequestTypeID,
	}
	if u == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Suggest",
			SchemaName: "suggest",
			Null:       !u.Flags.Has(3),
		},
		{
			Name:       "Save",
			SchemaName: "save",
			Null:       !u.Flags.Has(4),
		},
		{
			Name:       "UserID",
			SchemaName: "user_id",
		},
		{
			Name:       "File",
			SchemaName: "file",
			Null:       !u.Flags.Has(0),
		},
		{
			Name:       "Video",
			SchemaName: "video",
			Null:       !u.Flags.Has(1),
		},
		{
			Name:       "VideoStartTs",
			SchemaName: "video_start_ts",
			Null:       !u.Flags.Has(2),
		},
	}
	return typ
}

// SetFlags sets flags for non-zero fields.
func (u *PhotosUploadContactProfilePhotoRequest) SetFlags() {
	if !(u.Suggest == false) {
		u.Flags.Set(3)
	}
	if !(u.Save == false) {
		u.Flags.Set(4)
	}
	if !(u.File == nil) {
		u.Flags.Set(0)
	}
	if !(u.Video == nil) {
		u.Flags.Set(1)
	}
	if !(u.VideoStartTs == 0) {
		u.Flags.Set(2)
	}
}

// Encode implements bin.Encoder.
func (u *PhotosUploadContactProfilePhotoRequest) Encode(b *bin.Buffer) error {
	if u == nil {
		return fmt.Errorf("can't encode photos.uploadContactProfilePhoto#b91a83bf as nil")
	}
	b.PutID(PhotosUploadContactProfilePhotoRequestTypeID)
	return u.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (u *PhotosUploadContactProfilePhotoRequest) EncodeBare(b *bin.Buffer) error {
	if u == nil {
		return fmt.Errorf("can't encode photos.uploadContactProfilePhoto#b91a83bf as nil")
	}
	u.SetFlags()
	if err := u.Flags.Encode(b); err != nil {
		return fmt.Errorf("unable to encode photos.uploadContactProfilePhoto#b91a83bf: field flags: %w", err)
	}
	if u.UserID == nil {
		return fmt.Errorf("unable to encode photos.uploadContactProfilePhoto#b91a83bf: field user_id is nil")
	}
	if err := u.UserID.Encode(b); err != nil {
		return fmt.Errorf("unable to encode photos.uploadContactProfilePhoto#b91a83bf: field user_id: %w", err)
	}
	if u.Flags.Has(0) {
		if u.File == nil {
			return fmt.Errorf("unable to encode photos.uploadContactProfilePhoto#b91a83bf: field file is nil")
		}
		if err := u.File.Encode(b); err != nil {
			return fmt.Errorf("unable to encode photos.uploadContactProfilePhoto#b91a83bf: field file: %w", err)
		}
	}
	if u.Flags.Has(1) {
		if u.Video == nil {
			return fmt.Errorf("unable to encode photos.uploadContactProfilePhoto#b91a83bf: field video is nil")
		}
		if err := u.Video.Encode(b); err != nil {
			return fmt.Errorf("unable to encode photos.uploadContactProfilePhoto#b91a83bf: field video: %w", err)
		}
	}
	if u.Flags.Has(2) {
		b.PutDouble(u.VideoStartTs)
	}
	return nil
}

// Decode implements bin.Decoder.
func (u *PhotosUploadContactProfilePhotoRequest) Decode(b *bin.Buffer) error {
	if u == nil {
		return fmt.Errorf("can't decode photos.uploadContactProfilePhoto#b91a83bf to nil")
	}
	if err := b.ConsumeID(PhotosUploadContactProfilePhotoRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode photos.uploadContactProfilePhoto#b91a83bf: %w", err)
	}
	return u.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (u *PhotosUploadContactProfilePhotoRequest) DecodeBare(b *bin.Buffer) error {
	if u == nil {
		return fmt.Errorf("can't decode photos.uploadContactProfilePhoto#b91a83bf to nil")
	}
	{
		if err := u.Flags.Decode(b); err != nil {
			return fmt.Errorf("unable to decode photos.uploadContactProfilePhoto#b91a83bf: field flags: %w", err)
		}
	}
	u.Suggest = u.Flags.Has(3)
	u.Save = u.Flags.Has(4)
	{
		value, err := DecodeInputUser(b)
		if err != nil {
			return fmt.Errorf("unable to decode photos.uploadContactProfilePhoto#b91a83bf: field user_id: %w", err)
		}
		u.UserID = value
	}
	if u.Flags.Has(0) {
		value, err := DecodeInputFile(b)
		if err != nil {
			return fmt.Errorf("unable to decode photos.uploadContactProfilePhoto#b91a83bf: field file: %w", err)
		}
		u.File = value
	}
	if u.Flags.Has(1) {
		value, err := DecodeInputFile(b)
		if err != nil {
			return fmt.Errorf("unable to decode photos.uploadContactProfilePhoto#b91a83bf: field video: %w", err)
		}
		u.Video = value
	}
	if u.Flags.Has(2) {
		value, err := b.Double()
		if err != nil {
			return fmt.Errorf("unable to decode photos.uploadContactProfilePhoto#b91a83bf: field video_start_ts: %w", err)
		}
		u.VideoStartTs = value
	}
	return nil
}

// SetSuggest sets value of Suggest conditional field.
func (u *PhotosUploadContactProfilePhotoRequest) SetSuggest(value bool) {
	if value {
		u.Flags.Set(3)
		u.Suggest = true
	} else {
		u.Flags.Unset(3)
		u.Suggest = false
	}
}

// GetSuggest returns value of Suggest conditional field.
func (u *PhotosUploadContactProfilePhotoRequest) GetSuggest() (value bool) {
	if u == nil {
		return
	}
	return u.Flags.Has(3)
}

// SetSave sets value of Save conditional field.
func (u *PhotosUploadContactProfilePhotoRequest) SetSave(value bool) {
	if value {
		u.Flags.Set(4)
		u.Save = true
	} else {
		u.Flags.Unset(4)
		u.Save = false
	}
}

// GetSave returns value of Save conditional field.
func (u *PhotosUploadContactProfilePhotoRequest) GetSave() (value bool) {
	if u == nil {
		return
	}
	return u.Flags.Has(4)
}

// GetUserID returns value of UserID field.
func (u *PhotosUploadContactProfilePhotoRequest) GetUserID() (value InputUserClass) {
	if u == nil {
		return
	}
	return u.UserID
}

// SetFile sets value of File conditional field.
func (u *PhotosUploadContactProfilePhotoRequest) SetFile(value InputFileClass) {
	u.Flags.Set(0)
	u.File = value
}

// GetFile returns value of File conditional field and
// boolean which is true if field was set.
func (u *PhotosUploadContactProfilePhotoRequest) GetFile() (value InputFileClass, ok bool) {
	if u == nil {
		return
	}
	if !u.Flags.Has(0) {
		return value, false
	}
	return u.File, true
}

// SetVideo sets value of Video conditional field.
func (u *PhotosUploadContactProfilePhotoRequest) SetVideo(value InputFileClass) {
	u.Flags.Set(1)
	u.Video = value
}

// GetVideo returns value of Video conditional field and
// boolean which is true if field was set.
func (u *PhotosUploadContactProfilePhotoRequest) GetVideo() (value InputFileClass, ok bool) {
	if u == nil {
		return
	}
	if !u.Flags.Has(1) {
		return value, false
	}
	return u.Video, true
}

// SetVideoStartTs sets value of VideoStartTs conditional field.
func (u *PhotosUploadContactProfilePhotoRequest) SetVideoStartTs(value float64) {
	u.Flags.Set(2)
	u.VideoStartTs = value
}

// GetVideoStartTs returns value of VideoStartTs conditional field and
// boolean which is true if field was set.
func (u *PhotosUploadContactProfilePhotoRequest) GetVideoStartTs() (value float64, ok bool) {
	if u == nil {
		return
	}
	if !u.Flags.Has(2) {
		return value, false
	}
	return u.VideoStartTs, true
}

// PhotosUploadContactProfilePhoto invokes method photos.uploadContactProfilePhoto#b91a83bf returning error if any.
//
// See https://core.telegram.org/method/photos.uploadContactProfilePhoto for reference.
func (c *Client) PhotosUploadContactProfilePhoto(ctx context.Context, request *PhotosUploadContactProfilePhotoRequest) (*PhotosPhoto, error) {
	var result PhotosPhoto

	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return &result, nil
}
