// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// PremiumSubscriptionOption represents TL type `premiumSubscriptionOption#b6f11ebe`.
//
// See https://core.telegram.org/constructor/premiumSubscriptionOption for reference.
type PremiumSubscriptionOption struct {
	// Flags field of PremiumSubscriptionOption.
	Flags bin.Fields
	// Current field of PremiumSubscriptionOption.
	Current bool
	// CanPurchaseUpgrade field of PremiumSubscriptionOption.
	CanPurchaseUpgrade bool
	// Months field of PremiumSubscriptionOption.
	Months int
	// Currency field of PremiumSubscriptionOption.
	Currency string
	// Amount field of PremiumSubscriptionOption.
	Amount int64
	// BotURL field of PremiumSubscriptionOption.
	BotURL string
	// StoreProduct field of PremiumSubscriptionOption.
	//
	// Use SetStoreProduct and GetStoreProduct helpers.
	StoreProduct string
}

// PremiumSubscriptionOptionTypeID is TL type id of PremiumSubscriptionOption.
const PremiumSubscriptionOptionTypeID = 0xb6f11ebe

// Ensuring interfaces in compile-time for PremiumSubscriptionOption.
var (
	_ bin.Encoder     = &PremiumSubscriptionOption{}
	_ bin.Decoder     = &PremiumSubscriptionOption{}
	_ bin.BareEncoder = &PremiumSubscriptionOption{}
	_ bin.BareDecoder = &PremiumSubscriptionOption{}
)

func (p *PremiumSubscriptionOption) Zero() bool {
	if p == nil {
		return true
	}
	if !(p.Flags.Zero()) {
		return false
	}
	if !(p.Current == false) {
		return false
	}
	if !(p.CanPurchaseUpgrade == false) {
		return false
	}
	if !(p.Months == 0) {
		return false
	}
	if !(p.Currency == "") {
		return false
	}
	if !(p.Amount == 0) {
		return false
	}
	if !(p.BotURL == "") {
		return false
	}
	if !(p.StoreProduct == "") {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (p *PremiumSubscriptionOption) String() string {
	if p == nil {
		return "PremiumSubscriptionOption(nil)"
	}
	type Alias PremiumSubscriptionOption
	return fmt.Sprintf("PremiumSubscriptionOption%+v", Alias(*p))
}

// FillFrom fills PremiumSubscriptionOption from given interface.
func (p *PremiumSubscriptionOption) FillFrom(from interface {
	GetCurrent() (value bool)
	GetCanPurchaseUpgrade() (value bool)
	GetMonths() (value int)
	GetCurrency() (value string)
	GetAmount() (value int64)
	GetBotURL() (value string)
	GetStoreProduct() (value string, ok bool)
}) {
	p.Current = from.GetCurrent()
	p.CanPurchaseUpgrade = from.GetCanPurchaseUpgrade()
	p.Months = from.GetMonths()
	p.Currency = from.GetCurrency()
	p.Amount = from.GetAmount()
	p.BotURL = from.GetBotURL()
	if val, ok := from.GetStoreProduct(); ok {
		p.StoreProduct = val
	}

}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*PremiumSubscriptionOption) TypeID() uint32 {
	return PremiumSubscriptionOptionTypeID
}

// TypeName returns name of type in TL schema.
func (*PremiumSubscriptionOption) TypeName() string {
	return "premiumSubscriptionOption"
}

// TypeInfo returns info about TL type.
func (p *PremiumSubscriptionOption) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "premiumSubscriptionOption",
		ID:   PremiumSubscriptionOptionTypeID,
	}
	if p == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Current",
			SchemaName: "current",
			Null:       !p.Flags.Has(1),
		},
		{
			Name:       "CanPurchaseUpgrade",
			SchemaName: "can_purchase_upgrade",
			Null:       !p.Flags.Has(2),
		},
		{
			Name:       "Months",
			SchemaName: "months",
		},
		{
			Name:       "Currency",
			SchemaName: "currency",
		},
		{
			Name:       "Amount",
			SchemaName: "amount",
		},
		{
			Name:       "BotURL",
			SchemaName: "bot_url",
		},
		{
			Name:       "StoreProduct",
			SchemaName: "store_product",
			Null:       !p.Flags.Has(0),
		},
	}
	return typ
}

// SetFlags sets flags for non-zero fields.
func (p *PremiumSubscriptionOption) SetFlags() {
	if !(p.Current == false) {
		p.Flags.Set(1)
	}
	if !(p.CanPurchaseUpgrade == false) {
		p.Flags.Set(2)
	}
	if !(p.StoreProduct == "") {
		p.Flags.Set(0)
	}
}

// Encode implements bin.Encoder.
func (p *PremiumSubscriptionOption) Encode(b *bin.Buffer) error {
	if p == nil {
		return fmt.Errorf("can't encode premiumSubscriptionOption#b6f11ebe as nil")
	}
	b.PutID(PremiumSubscriptionOptionTypeID)
	return p.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (p *PremiumSubscriptionOption) EncodeBare(b *bin.Buffer) error {
	if p == nil {
		return fmt.Errorf("can't encode premiumSubscriptionOption#b6f11ebe as nil")
	}
	p.SetFlags()
	if err := p.Flags.Encode(b); err != nil {
		return fmt.Errorf("unable to encode premiumSubscriptionOption#b6f11ebe: field flags: %w", err)
	}
	b.PutInt(p.Months)
	b.PutString(p.Currency)
	b.PutLong(p.Amount)
	b.PutString(p.BotURL)
	if p.Flags.Has(0) {
		b.PutString(p.StoreProduct)
	}
	return nil
}

// Decode implements bin.Decoder.
func (p *PremiumSubscriptionOption) Decode(b *bin.Buffer) error {
	if p == nil {
		return fmt.Errorf("can't decode premiumSubscriptionOption#b6f11ebe to nil")
	}
	if err := b.ConsumeID(PremiumSubscriptionOptionTypeID); err != nil {
		return fmt.Errorf("unable to decode premiumSubscriptionOption#b6f11ebe: %w", err)
	}
	return p.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (p *PremiumSubscriptionOption) DecodeBare(b *bin.Buffer) error {
	if p == nil {
		return fmt.Errorf("can't decode premiumSubscriptionOption#b6f11ebe to nil")
	}
	{
		if err := p.Flags.Decode(b); err != nil {
			return fmt.Errorf("unable to decode premiumSubscriptionOption#b6f11ebe: field flags: %w", err)
		}
	}
	p.Current = p.Flags.Has(1)
	p.CanPurchaseUpgrade = p.Flags.Has(2)
	{
		value, err := b.Int()
		if err != nil {
			return fmt.Errorf("unable to decode premiumSubscriptionOption#b6f11ebe: field months: %w", err)
		}
		p.Months = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode premiumSubscriptionOption#b6f11ebe: field currency: %w", err)
		}
		p.Currency = value
	}
	{
		value, err := b.Long()
		if err != nil {
			return fmt.Errorf("unable to decode premiumSubscriptionOption#b6f11ebe: field amount: %w", err)
		}
		p.Amount = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode premiumSubscriptionOption#b6f11ebe: field bot_url: %w", err)
		}
		p.BotURL = value
	}
	if p.Flags.Has(0) {
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode premiumSubscriptionOption#b6f11ebe: field store_product: %w", err)
		}
		p.StoreProduct = value
	}
	return nil
}

// SetCurrent sets value of Current conditional field.
func (p *PremiumSubscriptionOption) SetCurrent(value bool) {
	if value {
		p.Flags.Set(1)
		p.Current = true
	} else {
		p.Flags.Unset(1)
		p.Current = false
	}
}

// GetCurrent returns value of Current conditional field.
func (p *PremiumSubscriptionOption) GetCurrent() (value bool) {
	if p == nil {
		return
	}
	return p.Flags.Has(1)
}

// SetCanPurchaseUpgrade sets value of CanPurchaseUpgrade conditional field.
func (p *PremiumSubscriptionOption) SetCanPurchaseUpgrade(value bool) {
	if value {
		p.Flags.Set(2)
		p.CanPurchaseUpgrade = true
	} else {
		p.Flags.Unset(2)
		p.CanPurchaseUpgrade = false
	}
}

// GetCanPurchaseUpgrade returns value of CanPurchaseUpgrade conditional field.
func (p *PremiumSubscriptionOption) GetCanPurchaseUpgrade() (value bool) {
	if p == nil {
		return
	}
	return p.Flags.Has(2)
}

// GetMonths returns value of Months field.
func (p *PremiumSubscriptionOption) GetMonths() (value int) {
	if p == nil {
		return
	}
	return p.Months
}

// GetCurrency returns value of Currency field.
func (p *PremiumSubscriptionOption) GetCurrency() (value string) {
	if p == nil {
		return
	}
	return p.Currency
}

// GetAmount returns value of Amount field.
func (p *PremiumSubscriptionOption) GetAmount() (value int64) {
	if p == nil {
		return
	}
	return p.Amount
}

// GetBotURL returns value of BotURL field.
func (p *PremiumSubscriptionOption) GetBotURL() (value string) {
	if p == nil {
		return
	}
	return p.BotURL
}

// SetStoreProduct sets value of StoreProduct conditional field.
func (p *PremiumSubscriptionOption) SetStoreProduct(value string) {
	p.Flags.Set(0)
	p.StoreProduct = value
}

// GetStoreProduct returns value of StoreProduct conditional field and
// boolean which is true if field was set.
func (p *PremiumSubscriptionOption) GetStoreProduct() (value string, ok bool) {
	if p == nil {
		return
	}
	if !p.Flags.Has(0) {
		return value, false
	}
	return p.StoreProduct, true
}
